<?php
/* shopping cart
    name: Shopping Cart
	OneThird CMS coyright(c) team1/3 All Rights Reserved.
*/

	global $config,$tax_rate,$ut;
	if (!isset($config)) { die(); }
	
function check_zip_data($refl=false)
{
	global $p_circle, $params, $html, $database, $ut, $config;
	

	$path = $config['files_path'].DIRECTORY_SEPARATOR.$p_circle.DIRECTORY_SEPARATOR.'plugin'.DIRECTORY_SEPARATOR.'cart'.DIRECTORY_SEPARATOR;
	$ken_all = $path.'ken_all.zip';
	$csv = $path.'KEN_ALL.CSV';
	$db_name = 'post';
	
	if ( !check_rights('admin')) {
		return 'Need administrator rights';
	}

	if (!$refl && is_file($path.$db_name.'0.db')) {
		return;
	}
	
echo <<<EOT
<!doctype html>
<html lang="ja" xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="UTF-8"><title>データベース構築中</title>
  </head>
<body>
EOT;

	echo("<p>郵便番号データベースを更新中、しばらくお待ち下さい</p>");
	flush();

	$db = array();
	
	for ($i=0; $i < 10; ++$i) {
		$db[$i] = new DataBase('sqlite','','','',$path);
		if (!$db[$i]->open($db_name.$i)) {
			echo("<p>エラーが発生しました、再度開き直してください</p>");
			flush();
			exit();
		}
		$db[$i]->sql_begin();
		$db[$i]->sql_update( "CREATE TABLE 'data' (
			    'id' INTEGER PRIMARY KEY AUTOINCREMENT UNIQUE
			    ,'post' TEXT
			    ,'addr1' TEXT
			    ,'addr2' TEXT
		);");
	}


	//01101,"060  ","0600000","ﾎｯｶｲﾄﾞｳ","ｻｯﾎﾟﾛｼﾁｭｳｵｳｸ","ｲｶﾆｹｲｻｲｶﾞﾅｲﾊﾞｱｲ","北海道","札幌市中央区"
	
	$zip = new ZipArchive;
	if ($zip->open($ken_all) !== true) {
		echo("<p>エラーが発生しました、再度開き直してください</p>");
		flush();
		exit();
	}
	if (@$zip->extractTo($path) !== true) {
		echo("<p>エラーが発生しました、再度開き直してください</p>");
		flush();
		exit();
	}

	$hnd = @fopen($csv, "r");
	if ($hnd) {
		for ($i=0; $i < 150000;++$i) {
			$ln = fgets($hnd, 500);
			if ($ln === false) { break; }
			$ln = mb_convert_encoding($ln, 'utf-8', "SJIS");
			$ar = explode(',',$ln);
			$a1 = trim($ar[2],'" ');
			$a2 = trim($ar[6],'" ');
			$a3 = trim($ar[7],'" ');
			if ($ar[8]) {
				$ar[8] = trim($ar[8],'" ');
				if ($ar[8] != "以下に掲載がない場合") {
					$a3 = $a3." ".$ar[8];
				}
			}
			if (!$db[(int)substr($a1,0,1)]->sql_update( "insert into data (post,addr1,addr2) values(?,?,?) ",$a1,$a2,$a3)) {
			}
		}
		fclose($hnd);
	}
	for ($i=0; $i < 10; ++$i) {
		$db[$i]->sql_commit();
	}

	echo("<p>データベースの更新が終了しました、再度開き直してください</p>");
	flush();

echo <<<EOT
</body>
EOT;
	exit();

}

function cart_ctrl_page( &$page_ar )
{
	global $p_circle,$config,$params,$database,$html,$ut;
	
	if ( !check_rights('admin')) {
		return 'Need administrator rights';
	}
	$params['template'] = 'admin.tpl';
	
	$buff = '';

	$tab_ar=array();
	$tab_ar[] = array('name'=>'注文(未処理)',		'proc'=>'order_list', 'status'=>10 );
	$tab_ar[] = array('name'=>'注文(処理済)',		'proc'=>'order_list', 'status'=>11 );
	$tab_ar[] = array('name'=>'商品一覧',		'proc'=>'tab_order' );
	$tab_ar[] = array('name'=>'メール設定',		'proc'=>'mess_tab' );
	$tab_ar[] = array('name'=>'郵便番号設定',		'proc'=>'post_tab' );
	$tab_ar[] = array('name'=>'送料設定',		'proc'=>'post2_tab' );

	$m = get_cart_mess($page_ar);
	if (empty($m['mail'])) {
$buff.= <<<EOT
		<div style='padding:5px 0' >
			{$ut->icon('caution')}SHOPメールアドレスが設定されていません
		</div >
EOT;
	}
	if (empty($m['tel'])) {
$buff.= <<<EOT
		<div style='padding:5px 0' >
			{$ut->icon('caution')}SHOP電話番号が設定されていません
		</div >
EOT;
	}
	if (empty($m['shipping'])) {
$buff.= <<<EOT
		<div style='padding:5px 0' >
			{$ut->icon('caution')}発送元地域が指定されていません
		</div >
EOT;
	}

	if (isset($_GET['tab'])) {
		$p_tab=(int)($_GET['tab']);
	} else {
		$p_tab=0;
	}
	if (!isset($tab_ar[$p_tab])) {
		return;
	}


$buff.= <<<EOT
	<div style='margin-top:10px'>
		<div class='onethird-tab'>
			<ul class='tab-head clearfix'>
EOT;
			$i=0;
			for($i=0;$i<count($tab_ar);++$i) {
				$v = $tab_ar[$i];
				($i==$p_tab)?$act=" class='active' ":$act='';
				$buff.=("<li $act ><a href='{$ut->link($params['page']['id'],"&:mode=order&tab=$i")}' >{$v['name']}</a></li>");
			}
$buff.= <<<EOT
			</ul>

			<div class='tab-body'>
EOT;
			
			if ( function_exists($tab_ar[$p_tab]['proc'])) {
				$ar = array();
				$buff .= $tab_ar[$p_tab]['proc']( $ar, $tab_ar[$p_tab], $p_tab );
			} else {
			}
			
			
$buff.= <<<EOT
			</div>
		</div> 
	</div> 
EOT;
	
	return frame_renderer($buff);
}

function order_list( $ar, $m ,$p_tab )
{
	global $p_circle, $params, $html, $database, $ut, $config;

	$buff = '';
	$ar = $database->sql_select_all("select id,date,metadata from ".DBX."data_items where type=? and mode=? and circle=? limit 100",CART_ID,$m['status'],$p_circle);
	if ($ar) {
		foreach ($ar as $v) {
			$m = unserialize64($v['metadata']);
			$n = '';
			if (!empty($m['p_name'])) {
				$n = $m['p_name'];
			}
$buff.= <<<EOT
			<p style='padding:0;margin:0;line-height:180%'>
				<a href='{$ut->link($v['id'])}'>{$v['id']}</a> : {$ut->substr($v['date'],0,10)} : $n
			</p>
EOT;
		}
	} else {
$buff.= <<<EOT
		- データは登録されていません
EOT;
	}
	return $buff;
}

function post_tab( $ar, $m ,$p_tab )
{
	global $p_circle, $params, $html, $database, $ut, $config;
	
	$path = $config['files_path'].DIRECTORY_SEPARATOR.$p_circle.DIRECTORY_SEPARATOR.'plugin'.DIRECTORY_SEPARATOR.'cart'.DIRECTORY_SEPARATOR;
	$ken_all = $path.'ken_all.zip';
	$db_name = 'post';
	
	$alert = '';

	if (isset($_POST['file_upload'])) {
		if (!$_POST['file_upload']) {
			$alert .= 'Failed to upload (1)';
		} else {
			$file1 = $_FILES['file1'];

			$file1tmp   = $_FILES['file1']['tmp_name'];		//tmpファイル名
			$file1name  = $_FILES['file1']['name'];			//ローカルファイル名
			$file1size  = $_FILES['file1']['size'];			//ファイルサイズ
			$file1type  = $_FILES['file1']['type'];			//ファイルの種類
			
			if (basename($file1name) != 'ken_all.zip') {
				$alert .= 'ファイル名が違います ken_all.zip をダウンロードして下さい';
			} else {
				$info = pathinfo($file1name);
				if (is_uploaded_file($file1tmp)) {
					$date = date('ymdHis', $_SERVER['REQUEST_TIME']);
					$dst = $path.'ken_all.zip';
					if (move_uploaded_file ( $file1tmp , $dst )) {
						if ($info['extension'] == 'zip') {
							check_zip_data(true);
						} else {
							$alert .= 'upload failed';
							unlink( $dst );
						}
					} else {
						$alert .= 'upload failed.(2)';
					}
				} else {
					$alert .= 'upload failed.(3)';
				}
			}
		}
	}

	$buff = '';

$buff.= <<<EOT
	<input type='hidden' name='mdx' id='mdx' value='mod_circle' />
	<div class='onethird-setting'>
		<p style='color:red;font-weight:bold'>$alert</p>
		<p>現在の郵便番号データ: ken_all.zip 
EOT;
			if (is_file($ken_all)) {
				$t = filemtime($ken_all);
				$t = date('Y-m-d H:i:s', $t);
			} else {
				$t = "郵便番号データが見つかりません";
			}
$buff.= <<<EOT
			$t
		<p/>
		<p>
EOT;
		$total = 0;
		for ($i=0; $i <10 ; ++$i) {
			$db = new DataBase('sqlite','','','',$path);
			if ($db->open($db_name.$i)) {
				$ar = $db->sql_select_all( "select count(id) as c from  ".DBX."data ");
				if ($ar) {
					$total += $ar[0]['c'];
				}
			}
		}
		if ($total) {
$buff.= <<<EOT
			郵便番号データが({$total})件登録されています
EOT;
		}
$buff.= <<<EOT
		<p/>
		<p>
		<form id='form1' method='post' enctype='multipart/form-data' action='{$_SERVER['REQUEST_URI']}' >
			<input type='hidden' name='xtoken' value='{$params['login_user']['meta']['magic_str']}' />
			<input type=file name='file1' style='display:inline-block'>
			<input type=submit value='郵便番号データのアップロード' class='onethird-button ' />
			<input type='hidden' name='file_upload' value='true' />
		</form>
		</p>
		<p>- <a href='http://www.post.japanpost.jp/zipcode/dl/kogaki-zip.html'>郵便番号データのダウンロード</a> 
		  ( 全国版一括を使用してください ) </p>
	</div>
EOT;
	return $buff;

}

function post2_tab( $ar, $m ,$p_tab )
{
	global $p_circle, $params, $html, $database, $ut, $config;
	
	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'save_cart_setting' )  {
		$r = array();
		$r['result'] = false;
		$params['page']['meta']['shipping'] = $ut->safe_str($_POST['data']);
		if (mod_data_items($params['page'])) {
			$r['result'] = true;
		}
		echo( json_encode($r) );
		exit();
	}

$html['meta']['save_cart_setting'] = <<<EOT
	<script>
		function save_cart_setting(ar) {
			var a = \$('#shipping').val();
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: "ajax=save_cart_setting&data="+encodeURIComponent(a)
				, dataType:'json'
				, success: function(data){
					if (data['result']) {
						location.reload(true);
					}
				}
			});
		}
	</script>
EOT;
	
	$path = $config['files_path'].DIRECTORY_SEPARATOR.$p_circle.DIRECTORY_SEPARATOR.'plugin'.DIRECTORY_SEPARATOR.'cart'.DIRECTORY_SEPARATOR;
	$db_name = 'postage';

	$buff = '';

$buff.= <<<EOT
	<div class='onethird-setting'>
EOT;

		$db = new DataBase('sqlite','','','',$path);
		if ($db->open($db_name)) {
			$ar = $db->sql_select_all( "select area,id,price from 'data' ;");
			foreach ($ar as $v) {
				$x = str_replace(array("\r","\n"),' ',$v['area']);
				$x = str_replace("  "," ",$x);
				$x = str_replace(" ","・",$x);
				if ($x != $v['area']) {
					$db->sql_update( "update 'data' set area=? where id=? ;",$x,$v['id']);
				}
				$x = str_replace(',','',$v['price']);
				if ($x != $v['price']) {
					$db->sql_update( "update 'data' set price=? where id=? ;",$x,$v['id']);
				}
				if (empty($x)) {
					$db->sql_update( "delete from 'data' where id=? ;",$v['id']);
				}
			}
			
			$ar = $db->sql_select_all( "select carrier from 'data' group by carrier;");
			if ($ar) {
				foreach ($ar as $v) {
$buff.= <<<EOT
					<p>
						<span style='display:inline-block;width:100px;'>配送会社</span>  <select style='width:200px'><option>{$v['carrier']}</option></select>
					<p/>
EOT;
				}
			}
			
			$ar = $db->sql_select_all( "select name,data from 'area' ;");
			if ($ar) {
				$option = array();
				foreach ($ar as $v) {
					$v['data'] = str_replace(array('、',' '),',',$v['data']);
					$x = explode(',',$v['data']);
					foreach ($x as $vv) {
						$vv = str_replace('県','',$vv);
						$option[] = $vv;
					}
				}
$buff.= <<<EOT
				<p>
					<span style='display:inline-block;width:100px;'>配送元</span> 
					<select style='width:200px' id='shipping' >
						<option value=''> --- </option>
EOT;
						$shipping = '';
						if (!empty($params['page']['meta']['shipping']) ) {
							$shipping = $params['page']['meta']['shipping'];
						}
						foreach ($option as $v) {
							$s = '';
$buff.= <<<EOT
							<option {$ut->check($shipping == $v, ' selected ')}>{$v}</option>
EOT;
						}
$buff.= <<<EOT
					</select>
				<p/>
EOT;
			}

		}
		
$buff.= <<<EOT
		<p>
			<input type="button" class="onethird-button" value='Update' onclick='save_cart_setting()' />
		</p>
	</div>
EOT;
	return $buff;

}

function mess_tab( $ar, $m ,$p_tab )
{
	global $p_circle, $params, $html, $database, $ut, $config;
	
	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'save_cart_setting' )  {
		$r = array();
		$r['result'] = false;
		$params['page']['meta']['cart_name'] = $ut->safe_str($_POST['p_name']);
		$params['page']['meta']['cart_mail'] = $ut->safe_str($_POST['p_mail']);
		$params['page']['meta']['cart_tel'] = $ut->safe_str($_POST['p_tel']);
		$params['page']['meta']['cart_head'] = $ut->safe_str($_POST['p_head']);
		$params['page']['meta']['cart_footer'] = $ut->safe_str($_POST['p_footer']);
		if (mod_data_items($params['page'])) {
			$r['result'] = true;
		}
		echo( json_encode($r) );
		exit();
	}

$html['meta']['save_cart_setting'] = <<<EOT
	<script>
		function save_cart_setting(ar) {
			var opt = '';
			opt += "&p_name="+encodeURIComponent(\$('#p_name').val());
			opt += "&p_mail="+encodeURIComponent(\$('#p_mail').val());
			opt += "&p_tel="+encodeURIComponent(\$('#p_tel').val());
			opt += "&p_head="+encodeURIComponent(\$('#p_head').val());
			opt += "&p_footer="+encodeURIComponent(\$('#p_footer').val());
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: "ajax=save_cart_setting"+opt
				, dataType:'json'
				, success: function(data){
					if (data['result']) {
						location.reload(true);
					}
				}
			});
		}
	</script>
EOT;
	
	$buff = '';

$buff.= <<<EOT
	<div class='onethird-setting'>
EOT;
		$m = get_cart_mess($params['page']);
$buff.= <<<EOT
		SHOP名
		<input type='text' class='p_input' id='p_name' value='{$m['name']}' />
		SHOPメールアドレス
		<input type='text' class='p_input' id='p_mail' value='{$m['mail']}' />
		SHOP電話番号
		<input type='text' class='p_input' id='p_tel' value='{$m['tel']}' />
		注文メールヘッダ
		<textarea style='height:8em;width:100%;' id='p_head'  >{$m['head']}</textarea>
		注文メールフッダ
		<textarea style='height:12em;width:100%;' id='p_footer'  >{$m['footer']}</textarea>
		<p>
			<input type="button" class="onethird-button" value='Update' onclick='save_cart_setting()' />
		</p>
	</div>
EOT;
	return $buff;

}

function cart_ctrl_item( &$page_ar )
{
	global $p_circle,$config,$params,$database,$html,$ut;

	snippet_jqueryui();
$html['css'][] = <<<EOT
	<style>
		#order_report p {
			margin:0;
			padding: 3px 0;
		}
		#order_report span {
			display:inline-block;
			width:120px;
		}
		#order_report .action {
			padding-top:20px;
		}
	</style>
EOT;
$html['meta'][] = <<<EOT
	<script>
	\$(function(){
		\$.datepicker.setDefaults( \$.datepicker.regional[ "ja" ] );
		\$( ".datepicker" ).datepicker({ 
			dateFormat: "yy-mm-dd"
			, monthNames: [ "1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月" ]
			, dayNamesMin: [ "月", "火", "水", "木", "金", "土", "日" ]
		});
	});
	function send_info1() {
		if (!\$('#info1').val()) {
			alert('伝票番号が記入されていません');
			return;
		}
		if (!\$('#info3').val()) {
			alert('お届け予定日が記入されていません');
			return;
		}
		if (!confirm('発送メールを送ります、実行しますか?')) {
			return;
		}
		var opt = '';
		opt += '&info1' + "=" + decodeURIComponent(\$('#info1').val());
		opt += '&info3' + "=" + decodeURIComponent(\$('#info3').val());
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=send_info1"+opt
			, dataType:'json'
			, success: function(data){
				if (data['result']) {
					alert('送信しました');
				}
			}
		});
	}
	</script>
EOT;

	if (!check_rights('admin')) {
		return 'Need administrator rights';
	}
	
	$m = $page_ar['meta'];

	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'send_info1' )  {
		$r = array();
		$r['result'] = false;
		
		if (!read_pagedata($page_ar['link'], $parent_ar)) {
			echo( json_encode($r) );
			exit();
		}
		$r['opt'] = $opt = get_cart_mess($parent_ar);
		$r['info1'] = $ut->safe_str($_POST['info1']);
		$r['info3'] = $ut->safe_str($_POST['info3']);
		
		
$r['x'] = $buff = <<<EOT
{$m['p_name']} 様

{$opt['head']}

発送の準備ができましたので、
ご注文の商品を発送させていただきました。
到着までお待ちいただくようお願い致します。


---------------------------------------------------------------------
[受注番号]  {$page_ar['id']}
[注文日時]  {$page_ar['date']}
[送付先]    {$m['p_name']} 様
        〒{$m['p_post']} {$m['p_addr1']} {$m['p_addr2']}
        (TEL){$m['p_tel']}

[お荷物伝票番号] {$r['info1']}
[配送会社] 日本郵便
[お届け予定日] {$r['info3']}
[お届け時間帯] 
JPエクスプレス（ゆうパック)ホームページでご確認下さい。（18時以降に反映）
何かございましたらお気軽にお問い合わせ下さい。

またのご利用をお待ちしております。

{$opt['footer']}

EOT;
		$mail_ar = array();
		$r['to'] = $mail_ar['to'] =  $m['mail'];
		$r['cc'] = $mail_ar['cc'] =  $opt['mail'];
		$r['from'] = $mail_ar['from'] =  $opt['mail'];
		$mail_ar['user_nickname'] = $opt['name'];
		$mail_ar['subject'] = "{$opt['name']} 商品発送のお知らせ";
		$mail_ar['no-log'] = true;
		$mail_ar['message'] = $buff;

		$r['result'] = sx_send_mail($mail_ar);
		if ($r['result']) {
			$page_ar['mode'] = 11;
			mod_data_items($page_ar);
		}

		echo( json_encode($r) );
		exit();
	}

	$buff = '';

	if (empty($m['p_about_send_price'])) {$m['p_about_send_price']=0;}
$buff.= <<<EOT
	<div id='order_report'>
		<p class='title'>注文内容</p>
		<p>[受注番号] {$page_ar['id']}</p>
		<p>[日時]     {$page_ar['date']}</p>
		<p>[送付先] {$m['p_name']} : 
		〒{$m['p_post']} {$m['p_addr1']} {$m['p_addr2']}</p>
		<p>[TEL] {$m['p_tel']}</p>

		<p>[金額] {$ut->safe_price((int)$m['total_price']+(int)$m['total_tax'])} + {$ut->safe_price($m['p_about_send_price'])} + 260 
			= {$ut->safe_price((int)$m['total_price']+$m['total_tax']+(int)$m['p_about_send_price']+260)}円 </p>
		<p>[支払方法] {$m['p_payment']}</p>
		<p>[商品]</p>
EOT;
		foreach ($m['order'] as $v) {
$buff.= <<<EOT
			<p><a href='{$ut->link($v['id'])}'>{$v['title']} {$ut->safe_price($v['price'])}円 * {$v['count']}</a></p>
EOT;
			
		}
$buff.= <<<EOT
		</p>
EOT;
		if ($page_ar['mode']==10) {
$buff.= <<<EOT
			<hr />
			<p>{$m['p_etc']}</p>
			<p>
				<span>伝票番号</span> <input type='text' value='' id='info1' />
			</p>
			<p>
				<span>配送会社</span> <input type='text' value='日本郵便' id='info2' />
			</p>
			<p>
				<span>お届け予定日</span> <input type='text' value='' class='datepicker' id='info3' />
				<a href='http://www.post.japanpost.jp/deli_days/index.html' target='_blank'>http://www.post.japanpost.jp/deli_days/index.html</a>
			</p>
			<p class='action'>
				<input type='button' value='発送メール送信' class='onethird-button' onclick='send_info1()' />
			</p>
EOT;
		}
$buff.= <<<EOT
	</div>
EOT;

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		// 編集
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($page_ar['id'], 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;
	}

	$buff = frame_renderer(body_renderer($page_ar).$buff);
	$buff = custompage_renderer($page_ar['id'],$buff);

	return $buff;
}

function tab_order( $ar, $m ,$p_tab )
{
	global $p_circle, $params, $html, $database, $ut, $config;

	$buff = '';
	$sql = "select t0.id as id,t0.date as date,t1.metadata as metadata, t0.title as title from ".DBX."data_items as t0
				left join ".DBX."data_items as t1 on t1.link=t0.id 
				where t1.block_type=? and t1.type=? and t0.circle=?";
	$ar = $database->sql_select_all($sql,5, CART_ID,$p_circle);
	if ($ar) {
		foreach ($ar as $v) {
			$m = unserialize64($v['metadata']);
			$mode = '';
			if (isset($m['page_cart_mode'])) {
				$mode = $m['page_cart_mode'];
				if ($mode == 0) {
					$mode = '(停止)';
				} else if ($mode == 3) {
					$mode = '(非表示)';
				} else {
					$mode = '';
				}
			}
			if (empty($m['page_cart_price'])) {
				$mode = '価格エラー';
			}
			if ($mode) { $mode = "<span style='font-size:70%'>$mode</span>"; }
			$sb = '';
			if (!empty($m['page_cart_title'])) {
				$sb = " <span style='font-size:70%'>({$m['page_cart_title']}) </span>";
			}
$buff.= <<<EOT
			<p style='padding:0;margin:0;line-height:180%'>
				<a href='{$ut->link($v['id'])}'>{$ut->substr($v['date'],0,10)} : {$v['id']} : {$v['title']} $sb</a> $mode
			</p>
EOT;
		}
	} else {
$buff.= <<<EOT
		- データは登録されていません
EOT;
	}
	return $buff;
}

?>